Option Explicit


Const ForReading = 1
Const ForWriting = 2
Const ForAppending = 8 

dim inTxt,outTxt
dim mifNew,mifOld,midNew,midOld
dim strText, header, i,j,K,L,N,t,s
dim fso,objFileIn,objFileOut
dim objArgs
dim help

	help=WScript.ScriptName & "      MIF   mifPath  mifName" & vbnewline & _
		"    MIF   MID-" & vbnewline & _
		"  :" & vbnewline & _
		" " & WScript.ScriptName & " MIF_" & " [0 / 1 / 2 / 3 / ... / n / FULL] " & vbnewline & _
		"   :" & vbnewline & _
		"            [mifPath]"  & vbnewline & _
		"     FULL -       [mifPath].    ."  & vbnewline & _
		"     0    -  [mifPath]   ."   & vbnewline & _
		"     1    -   [mifPath]     ."   & vbnewline & _
		"     2    -  [mifPath]         ."   & vbnewline & _
		"     n    -  [mifPath]    n  ."   & vbnewline & _
		"      "   

	Set objArgs = WScript.Arguments

	if WScript.Arguments.Count < 1 or WScript.Arguments.Count > 2 then
		WScript.Echo help
		WScript.Quit -1
	End If
	
	set objFileIn=Nothing
	set objFileOut=Nothing
	
	Set fso = CreateObject("Scripting.FileSystemObject")
	inTxt=fso.GetAbsolutePathName(objArgs(0))

	if fso.FileExists(inTxt) then
		Set objFileIn = fso.OpenTextFile(inTxt, ForReading, false)
	else
		WScript.Echo "Error:: file '" & inTxt & "' not exist."
		WScript.Quit -2
	end if

	if WScript.Arguments.Count < 2 then
		N=254
	else
		N=objArgs(1)
		if not IsNumeric(N) then N=254 else N=CLng(N)
	End If
	'' WScript.Echo "N = " & Cstr(N)
	outTxt=inTxt & ".new"

	WScript.Echo "++ " & now() & " " & WScript.ScriptName & " MIF_file='" & inTxt 
	WScript.Echo " ** Open  '" & inTxt & "' at " & now 

	Set objFileOut = fso.CreateTextFile(outTxt,True)
	
	Do While objFileIn.AtEndOfStream <> True
		t=objFileIn.Readline
		i=InStr(Lcase(Trim(t)),"columns ")
		if i=1 then
			s=mid(Trim(t),len("columns "))
			if IsNumeric(s) then L=CLng(s)
			L=L+2
			t="Columns "  & CStr(L) 
			objFileOut.Write t & vbNewLine
			REM WScript.Echo "  !-> " & t 
			exit Do
		else
			REM WScript.Echo "  --> " & t 
			objFileOut.Write t & vbNewLine
		end if
	loop 

	Do While objFileIn.AtEndOfStream <> True
		t=objFileIn.Readline
		if Ucase(Trim(t)) = "DATA" then
			objFileOut.Write "   mifPath Char (254)"  & vbNewLine
			objFileOut.Write "   mifName Char (120)"  & vbNewLine
			objFileOut.Write t & vbNewLine
			exit Do
		else
			'' WScript.Echo "  --> " & t 
			objFileOut.Write t & vbNewLine
		end if
	loop 

	Do While objFileIn.AtEndOfStream <> True
		t=objFileIn.Readline
			'' WScript.Echo "  --> " & t 
			objFileOut.Write t & vbNewLine
	loop 
	
	if not objFileIn is Nothing then 
		objFileIn.close
		set objFileIn=Nothing
	end if

	if not objFileOut is Nothing then 
		objFileOut.close
	set objFileOut=Nothing
	end if

	mifNew=outTxt
	mifOld=inTxt
	WScript.Echo " ** Close '" & inTxt & "' at " & now 
	
	'' ---------------- MID -----
	t=right(inTxt,1)
	if UCase(t)="F" then
		inTxt=left(inTxt,len(inTxt)-1) & Chr(Asc(t)-Asc("F")+Asc("D"))
		REM WScript.Echo "  !!> " & inTxt
	else
		WScript.Echo "Error:: file '" & inTxt & "' has not '.MIF' extention."
		WScript.Quit -4
	end if 
	
	if fso.FileExists(inTxt) then
		Set objFileIn = fso.OpenTextFile(inTxt, ForReading, false)
	else
		WScript.Echo "Error:: file '" & inTxt & "' not exist."
		WScript.Quit -5
	end if
	outTxt=inTxt & ".new"

	WScript.Echo "++ " & now() & " " & WScript.ScriptName & " MID_file='" & inTxt 
	WScript.Echo " ** Open  '" & inTxt & "' at " & now 

	Set objFileOut = fso.CreateTextFile(outTxt,True)
	
	dim mPath, mName
	mName=fso.GetFileName(mifOld)
	mPath=fso.GetParentFolderName(mifOld)
	
	REM WScript.Echo "  !!> " & mName & vbTab & mPath
	
	t=vbNullString
	if N=0 then
		mPath=vbNullString
	elseif N < 254 then
		K=1
		j=InstrRev(mPath,"\",-1)
		do while (N> K) And (j > 0)   
			j=InstrRev(mPath,"\",j-1)
			K=K+1
			REM if j > 0 then t=mid(mPath,j+1) else t=vbNullString
			REM WScript.Echo "  --> " & "N=" & N & ", K=" & K & vbtab & t
		loop
		if j > 0 then mPath = mid(mPath,j+1)
	end if
	REM WScript.Echo "  !!> " & mName & vbTab & mPath


	Do While objFileIn.AtEndOfStream <> True
		t=objFileIn.Readline
		if len(t) > 0 then 
			t=t & ",""" & mPath & """,""" & mName & """"
		else
			t="""" & mPath & """,""" & mName & """"
		end if
		objFileOut.Write t & vbNewLine
	loop

	if not objFileIn is Nothing then 
		objFileIn.close
		set objFileIn=Nothing
	end if

	if not objFileOut is Nothing then 
		objFileOut.close
	set objFileOut=Nothing
	end if
	midNew=outTxt
	midOld=inTxt
	WScript.Echo " ** Close '" & inTxt & "' at " & now 

	'' ---------------- Rename files -----
	if fso.FileExists(midOld & ".bak") then
		fso.DeleteFile midOld & ".bak",True
	end if
	if fso.FileExists(mifOld & ".bak") then
		fso.DeleteFile mifOld & ".bak",True
	end if
	fso.MoveFile mifOld, mifOld & ".bak"
	fso.MoveFile midOld, midOld & ".bak"

		fso.MoveFile mifNew, mifOld
		fso.MoveFile midNew, midOld

	
	
	
	'' ExitSub:
	'' on error resume next
	if not objFileIn is Nothing then 
		objFileIn.close
		set objFileIn=Nothing
	end if

	if not objFileOut is Nothing then 
		objFileOut.close
	set objFileOut=Nothing
	end if

	WScript.Echo "xx " & now() & " " & WScript.ScriptName & " MIF_file='" & inTxt 

